<?php
Aseco::registerEvent("onCheckpoint", "seclive_cp");
Aseco::registerEvent("onPlayerFinish", "seclive_finish");
Aseco::registerEvent("onNewChallenge", "seclive_newChallenge");
Aseco::registerEvent('onBeginRound', 'seclive_BeginRound');
Aseco::registerEvent('onBeginChallenge', 'seclive_BeginChallenge');
Aseco::registerEvent('onEndRace', 'seclive_endRace');
Aseco::registerEvent("onStartup", "seclive_init");


function seclive_init($aseco, $command) {
global $seclive;
$seclive =new seclive();
$seclive->Aseco=$aseco;
setCustomUIField("checkpoint_list", false); 
}

function seclive_endRace($aseco, $command) {
global $seclive;
$seclive->onEndRace();
}

function seclive_newChallenge($aseco, $command) {
global $seclive;
$seclive->onNewChallenge($command);

}

function seclive_BeginRound($aseco, $command) {
global $seclive;
$seclive->onBeginRound($command);
}

function seclive_BeginChallenge($aseco, $command) {
global $seclive;
$seclive->onBeginChallenge($command);
}


function seclive_finish($aseco, $command) {
global $seclive;
$seclive->onFinish($command);
}

function seclive_cp($aseco, $command) {
global $seclive;
$seclive->onCP($command);
}



class seclive { 
var $Aseco;
private $starts = true;
private $totalCP;
private $enabled = true;
private $lapsLimit;
private $cpTimings; // an array, see function calcCP 
private $playerTimes = array();
private $sectorTimes = array();
private $bestTimes = array();

function onNewChallenge($challenge) {
		$totalCP = $challenge->nbchecks;
	$this->enabled = true;
	if ($this->starts == true) {
	$this->starts = false;
	$this->enabled = false; 
	$this->sendChat("Sectors disabled, new start of Xaseco.");
	}
	if ($totalCP < 5) { 
	$this->enabled = false; 
	$this->sendChat("Sectors disabled, not enough checkpoints.");
	}
	
	$this->totalCP = $totalCP;
	$this->lapsLimit = $this->Aseco->server->gameinfo->lapslimit;
	$this->cpTimings = $this->calcCP($totalCP); 
	unset($this->playerTimes);
	unset($this->sectorTimes);
	unset($this->bestTimes);
}


function onCp($command) {
	if (!$this->enabled) return;
	// command = array();
	//0 = playerid, 1 = login, 2 = time, 3=labnb, 4=cpnb;
	$login = $command[1];
	$lap = $command[3];
	$cpn = $command[4];
	$cp = ($command[4] + 1) - ($lap * $this->totalCP);
	$time = $command[2];
	$isNewSector = false;

	// set laptimes to array
	if ($cp != 0) { 
		$this->playerTimes[$login]['laps'][$lap][$cp] = $time - $this->playerTimes[$login]['oldtime'];
		$this->playerTimes[$login]['newlap'] = false;
	}
	else  { 
	$this->playerTimes[$login]['laps'][$lap][$cp] = $time - $this->playerTimes[$login]['oldtime'];
	$this->playerTimes[$login]['newlap'] = true;
	$this->playerTimes[$login]['laps'][$lap-1][$this->totalCP] = $this->playerTimes[$login]['laps'][$lap][0];
	}
	
	unset($this->playerTimes[$login]['laps'][$lap][0]); // unset the variable of 0 of eachlap
	
	//print_r($this->playerTimes[$login]);
	
	// calculate the lastcp of sectors 
	$cpTimings = $this->cpTimings;
	$sect1 = $cpTimings[0][(count($cpTimings[0])-1)];
	$sect2 = $cpTimings[1][(count($cpTimings[1])-1)];
	$sect3 = $cpTimings[2][(count($cpTimings[2])-1)];
		
	if ($sect1 == $cp || $sect2 == $cp ) {
		$sector = key(getParentStack($cp,$cpTimings));  // get sectornumber from checkpoint
		foreach( $cpTimings[$sector] as $cpT) {  // go thought all cps in sector
			$sectorTime += $this->playerTimes[$login]['laps'][$lap][$cpT]; // add cp time, to sectortime
		}
		$this->playerTimes[$login]['sect'][$lap][$sector] = $sectorTime;
		$isNewSector = true;
	}

	if ($this->playerTimes[$login]['newlap'] === true) {
		$sector = 2;
		foreach( $cpTimings[2] as $cpT) { // go thought all cps in last sector
			$sectorTime += $this->playerTimes[$login]['laps'][($lap-1)][$cpT]; // add cp time, to sectortime
		}
		$this->playerTimes[$login]['sect'][($lap-1)][2] = $sectorTime;
		$isNewSector = true;			
	}
    // compare the sectortime with previous best, update if better.
	if ($isNewSector) { 
		if (isset($this->sectorTimes[$login][$sector])) {
			if ($this->sectorTimes[$login][$sector] > $sectorTime) {  // if newtime is better
				$temp = formatTime($sectorTime);
			//	$this->sendChat("Login: $login. sector $sector --> new time $temp");
				$this->sectorTimes[$login][$sector] = $sectorTime;	  // update
				$this->bestTimes[$sector][$sectorTime] = $login;
			}			
		} else {
			$temp = formatTime($sectorTime);
		//	$this->sendChat("Login: $login. INIT sector $sector --> new time $temp");
			$this->sectorTimes[$login][$sector] = $sectorTime;
			$this->bestTimes[$sector][$sectorTime] = $login;
		}
			
		// print_r($this->sectorTimes[$login]);
		$this->updateManialinks();
		
		}
	
	$this->playerTimes[$login]['oldtime'] = $time;
}
function updateManialinks() {
		$line = 0;
		$sect1 = $this->bestTimes[0];
		$sect2 = $this->bestTimes[1];
		$sect3 = $this->bestTimes[2];
		
		ksort($sect1, SORT_NUMERIC);
		if (!empty($sect2)) ksort($sect2, SORT_NUMERIC);
		if (!empty($sect3)) ksort($sect3, SORT_NUMERIC);
		
		// get best of each sector and putit to new array;
		$x = 0;
		$best = array();
		if(count($sect1) > 0) {
			foreach($sect1 as $time => $login) {
				if ($x == 0) $sectimes[0] = array($time, $this->Aseco->server->players->player_list[$login]->nickname);
				$best[] = $login;
				$x++;
				}
				
			}
		
	
		if(count($sect2) > 0) {
			foreach($sect2 as $time => $login) {
				$sectimes[1] = array($time, $this->Aseco->server->players->player_list[$login]->nickname);
				break;
			}
		}
	
		if(count($sect3) > 0) {
			foreach($sect3 as $time => $login) {
				$sectimes[2] = array($time, $this->Aseco->server->players->player_list[$login]->nickname);
				break;
			}
		}
	
		$xml = '<manialink id="284725897">
				<frame posn="15 -35 1">
				<format style="TextCardInfoSmall" textsize="1.2" />		
		';
		for($x = 0; $x <= 2; $x++) {
		$xml .= '<label posn="0 '.$line.' 2" sizen="20 2" halign="left" valign="center"  text="$z$s sect'.($x+1) .". ".$sectimes[$x][1].'"/>';
		$xml .= '<label posn="21 '.$line.' 2" sizen="10 2" halign="left" valign="center"  text="$z$s'.formatTime($sectimes[$x][0]).'"/>';
		$line-=2.7;
		}
		$xml .='</frame></manialink>';
		
		$xml2 = '<manialink id="284725898">
		<frame posn="-63 47 1">
		<format style="TextCardInfoSmall" textsize="1.2" />	
		';
		
		$x = 0;
		$line = 0;
		$best = array_unique($best);
		
		$xml2 .= '<label posn="20 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s Sector 1"/>';
		$xml2 .= '<label posn="30 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s Sector 2"/>';
		$xml2 .= '<label posn="40 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s Sector 3"/>';
		foreach($best as $login) {
		if ($x > 4) break;
		$line-=2.7;
		$nick = $this->Aseco->server->players->player_list[$login]->nickname;
		$xml2 .= '<label posn="0 '.$line.' 2" sizen="20 2" halign="left" valign="center"  text="$z$s '.($x+1) .". ".$nick.'"/>';
		$xml2 .= '<label posn="20 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s'.formatTime($this->sectorTimes[$login][0]).'"/>';
		$xml2 .= '<label posn="30 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s'.formatTime($this->sectorTimes[$login][1]).'"/>';
		$xml2 .= '<label posn="40 '.$line.' 2" sizen="5 2" halign="left" valign="center"  text="$z$s'.formatTime($this->sectorTimes[$login][2]).'"/>';
		$x++;
		}
		$xml2 .='</frame></manialink>';
		
		//print $xml;
		$this->Aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
		$this->Aseco->client->addCall('SendDisplayManialinkPage', array($xml2, 0, false));
		//print_r($this->Aseco->client->getResponse());

}
function onEndRace() {
	$xml = '<manialink id="284725897"></manialink><manialink id="284725898"></manialink>';
$this->Aseco->client->addCall('SendDisplayManialinkPage', array($xml, 0, false));
}

function onBeginChallenge() {

}
function onBeginRound($command) {
$this->playerTimes[$login]['oldtime'] = 0;
}

function onFinish($command) {
}

function sendChat($message, $login = '') {
	if ($login){
			$this->Aseco->addCall('ChatSendServerMessageToLogin', array($message, $login));
		} else {
			$this->Aseco->addCall('ChatSendServerMessage', array($message));
		}
}	

function calcCP($totalcps) {
// for 8 checkpoints, the array will be as following:
//	[0] => Array
//        (
//            [0] => 1
//            [1] => 2
//            [2] => 3
//        )
//
//    [1] => Array
//        (
//            [0] => 4
//            [1] => 5
//            [2] => 6
//        )
//
//    [2] => Array
//        (
//            [0] => 7
//            [1] => 8
//        )	
	$cpsect = floor($totalcps*0.33);
	$sect = 0;
	$cp=0;
	$array = array();
	
	for($x = 0; $x < $totalcps; $x++)
	{
	
		if ($x%($cpsect+1) == 0) {
			$cp++;	
			$sect++;
			$array[$sect-1][] = $cp;
			
		} else {
			$cp++;
			$array[$sect-1][] = $cp;
		}
	
	}
	return $array; 
}


} // end of class

function getParentStack($child, $stack) {
// function from php.net
// http://fi.php.net/manual/en/function.array-search.php
    foreach ($stack as $k => $v) {
        if (is_array($v)) {
            // If the current element of the array is an array, recurse it and capture the return
            $return = getParentStack($child, $v);
            
            // If the return is an array, stack it and return it
            if (is_array($return)) {
                return array($k => $return);
            }
        } else {
            // Since we are not on an array, compare directly
            if ($v == $child) {
                // And if we match, stack it and return it
                return array($k => $child);
            }
        }
    }
    
    // Return false since there was nothing found
    return false;
}
?>